searchNodes=[{"doc":"This module provides the main API to interface with a StasD/DogStatsD agent. Getting started A new instance of Dogmatix can be started via the start_link/2 function: { :ok , pid } = Dogmatix . start_link ( &quot;my_dogmatix&quot; , &quot;localhost&quot; , 8125 ) This will create a new instance named &quot;my_dogmatix&quot;, communicating via UDP with an agent located at localhost:8125 . This instance will use all the default options. Instantiation via a custom module defmodule MyApp.Dogmatix do use Dogmatix end MyApp.Dogmatix . start_link ( &quot;localhost&quot; , 8125 ) Your custom module can then be used without having to provide the name of your Dogmatix instance: MyApp.Dogmatix . increment ( &quot;my_counter&quot; ) Configuration Various options can be provided to start_link to configure the instance: :worker_count - (positive integer) - number of UDP sockets and workers used to distribute the metrics. Defaults to 4 . :prefix - (binary) - all metrics sent to the agent will be prefixed with this value. Not set by default. :tags - ([binary]) - a list of tags to be sent with all metrics. Format: [&quot;tag1:value1&quot;, &quot;tag2:value2&quot;] . Not set by default. :max_datagram_size - (integer) - the maximum number of bytes for a message that can be sent. Defaults to 1432 . :buffer_flush_ms - (integer) - metric flush interval in milliseconds. Defaults to 500 . Sending metrics The module provides the functions to send all the supported metrics, event and service checks to the agent. All the functions accept the following options: :tags - ([binary]) - to add metric specific tags to the global tags :timeout - (integer) - a timeout value in milliseconds to be used when calling a worker from the pool. Defaults to 1000 . Sampling All metric-sending functions support a :sample_rate options. A sample rate is a float between 0 and 1 representing the percentage of packets that are effectively sent to the agent. Dogmatix . count ( &quot;my_dogmatix&quot; , &quot;current_users&quot; , 1 , sample_rate : 0.2 ) In the example above, only 20% of the calls will effectively send a packet to the agent. Agents supporting sampling will adjust the value according to the sample rate. Tagging Metrics, events and service checks can be tagged to add dimensions to their information. Note that not all agents support this feature. Constant tags can be defined when instantiating a Dogmatix client: Dogmatix . start_link ( &quot;my_dogmatix&quot; , &quot;localhost&quot; , 8125 , tags : [ &quot;env:dev&quot; ] ) In the example above, all metrics, events and service checks sent with this instance will be tagged with &quot;env:dev&quot;. Additionally, all functions support the :tags option to add ad-hoc tags. Dogmatix . increment ( &quot;my_dogmatix&quot; , &quot;page_views&quot; , tags : [ &quot;page:home&quot; ] ) In the example above, the metric &quot;page_views&quot; will be tagged with both &quot;page:home&quot; (and &quot;env:dev&quot;). Pooling For each instance of Dogmatix, a pool of worker/socket is started to format and send datagrams. The amount of workers can be configured via the :worker_count options when starting the instance. Metric Buffering In order to reduce network traffic, Dogmatix supports metric buffering. It attempts to group as many metrics as possible into a single datagram before sending to the agent. This behavior can be configured via two instantiation options: :max_datagram_size An integer representing the maximum size in bytes of a datagram. Make sure to configure a size that does not exceed the Agent-side per-datagram buffer size or the network/OS max datagram size. The default value is 1432 - the largest possible size given the Ethernet MTU of 1514 bytes. :buffer_flush_ms An integer representing in milliseconds the frequency of datagram buffer flush. Each worker/socket maintains its own local buffered datagram, i.e. an accumulation of metrics to be sent once the size of the datagram reaches the maximum possible size of a packet. For the case where your application does not capture metrics frequently, Dogmatix will regularly flush these buffers to make sure that buffered metrics are sent to the agent in a timely manner. The default value is 500 . If your application is so &quot;metric intensive&quot; that there is no chance of seeing your metrics lingering in the buffer, you can disable this behavior completely by setting this option to 0 .","ref":"Dogmatix.html","title":"Dogmatix","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Dogmatix.html#child_spec/1","title":"Dogmatix.child_spec/1","type":"function"},{"doc":"Changes the counter identified by metric_name by the given value . Examples iex&gt; Dogmatix . count ( &quot;my_dogmatix&quot; , &quot;cache_hits&quot; , 4 ) :ok","ref":"Dogmatix.html#count/4","title":"Dogmatix.count/4","type":"function"},{"doc":"Decrements the counter identified by metric_name by 1. Equivalent to calling count/4 with a value of -1. Examples iex&gt; Dogmatix . decrement ( &quot;my_dogmatix&quot; , &quot;current_users&quot; ) :ok","ref":"Dogmatix.html#decrement/3","title":"Dogmatix.decrement/3","type":"function"},{"doc":"Writes value to the distribution identified by metric_name . Examples iex&gt; Dogmatix . set ( &quot;my_dogmatix&quot; , &quot;response_time&quot; , 9 ) :ok","ref":"Dogmatix.html#distribution/4","title":"Dogmatix.distribution/4","type":"function"},{"doc":"Sends the provided event. Examples iex&gt; Dogmatix . event ( &quot;my_dogmatix&quot; , % Dogmatix.Event { title : &quot;An error occurred&quot; , text : &quot;Error message&quot; } ) :ok","ref":"Dogmatix.html#event/3","title":"Dogmatix.event/3","type":"function"},{"doc":"Sets the value of the gauge identified by metric_name to the given value . Examples iex&gt; Dogmatix . gauge ( &quot;my_dogmatix&quot; , &quot;disk_usage&quot; , 0.75 ) :ok","ref":"Dogmatix.html#gauge/4","title":"Dogmatix.gauge/4","type":"function"},{"doc":"Writes value to the histogram identified by metric_name . Examples iex&gt; Dogmatix . histogram ( &quot;my_dogmatix&quot; , &quot;page_views&quot; , 15 ) :ok","ref":"Dogmatix.html#histogram/4","title":"Dogmatix.histogram/4","type":"function"},{"doc":"Increments the counter identified by metric_name by 1. Equivalent to calling count/4 with a value of 1. Examples iex&gt; Dogmatix . increment ( &quot;my_dogmatix&quot; , &quot;page_views&quot; ) :ok","ref":"Dogmatix.html#increment/3","title":"Dogmatix.increment/3","type":"function"},{"doc":"Sends the provided service check. Examples iex&gt; Dogmatix . event ( &quot;my_dogmatix&quot; , % Dogmatix.ServiceCheck { name : &quot;application_check&quot; , status : :ok , message : &quot;All good!&quot; } ) :ok","ref":"Dogmatix.html#service_check/3","title":"Dogmatix.service_check/3","type":"function"},{"doc":"Writes value to the set identified by metric_name . Examples iex&gt; Dogmatix . set ( &quot;my_dogmatix&quot; , &quot;metric.set&quot; , 42 ) :ok","ref":"Dogmatix.html#set/4","title":"Dogmatix.set/4","type":"function"},{"doc":"Starts a new pool of connection to an agent. name - a binary or an atom to identify this instance of Dogmatix host - a binary, the agent's host port - a positive integer, the agent's host Options See the module documentation for details. :worker_count - (positive integer) - number of UDP sockets and workers used to distribute the metrics. Defaults to 4 . :prefix - (binary) - all metrics sent to the agent will be prefixed with this value. Not set by default. :tags - ([binary]) - a list of tags to be sent with all metrics. Format: [&quot;tag1:value1&quot;, &quot;tag2:value2&quot;] . Not set by default. :max_datagram_size - (integer) - the maximum number of bytes for a message that can be sent. Defaults to 1432 . :buffer_flush_ms - (integer) - metric flush interval in milliseconds. Defaults to 500 . 0 to disable.","ref":"Dogmatix.html#start_link/4","title":"Dogmatix.start_link/4","type":"function"},{"doc":"Writes value to the timer identified by metric_name . Examples iex&gt; Dogmatix . timer ( &quot;my_dogmatix&quot; , &quot;query_latency&quot; , 15 ) :ok","ref":"Dogmatix.html#timer/4","title":"Dogmatix.timer/4","type":"function"},{"doc":"","ref":"Dogmatix.html#t:id/0","title":"Dogmatix.id/0","type":"type"},{"doc":"","ref":"Dogmatix.html#t:metric_option/0","title":"Dogmatix.metric_option/0","type":"type"},{"doc":"","ref":"Dogmatix.html#t:metric_options/0","title":"Dogmatix.metric_options/0","type":"type"},{"doc":"","ref":"Dogmatix.html#t:metric_result/0","title":"Dogmatix.metric_result/0","type":"type"},{"doc":"","ref":"Dogmatix.html#t:metric_value/0","title":"Dogmatix.metric_value/0","type":"type"},{"doc":"","ref":"Dogmatix.html#t:start_option/0","title":"Dogmatix.start_option/0","type":"type"},{"doc":"","ref":"Dogmatix.html#t:start_options/0","title":"Dogmatix.start_options/0","type":"type"},{"doc":"The struct to define an event.","ref":"Dogmatix.Event.html","title":"Dogmatix.Event","type":"module"},{"doc":"","ref":"Dogmatix.Event.html#t:t/0","title":"Dogmatix.Event.t/0","type":"type"},{"doc":"The struct to define a service check.","ref":"Dogmatix.ServiceCheck.html","title":"Dogmatix.ServiceCheck","type":"module"},{"doc":"","ref":"Dogmatix.ServiceCheck.html#t:t/0","title":"Dogmatix.ServiceCheck.t/0","type":"type"},{"doc":"Dogmatix A StatsD/DogStatsD client for Elixir. Dogmatix is a StatsD/DogStatsD client build in Elixir. It is primarily designed to support the protocol and extensions provided by the DataDog agent , but works with any StatsD-compatible server.","ref":"readme.html","title":"Dogmatix","type":"extras"},{"doc":"This library is still in its early stages. Currently, the main supported features are: Communication with an agent via UDP Support for all types of metrics (count, gauge, timer, histogram, set and distribution) Support for events and service checks Support for metric sampling Support for tagging Connection pooling Metric buffering See the documentation for usage, configuration and implementation details.","ref":"readme.html#features","title":"Dogmatix - Features","type":"extras"},{"doc":"Add the :dogmatix dependency to your mix.exs file: def deps do [ { :dogmatix , &quot;~&gt; 0.1&quot; } ] end Then run mix deps.get in your shell to fetch the new dependency.","ref":"readme.html#installation","title":"Dogmatix - Installation","type":"extras"},{"doc":"The detailed documentation is available on HexDocs . An instance of the client can be started with Dogmatix.start_link/4 : { :ok , pid } = Dogmatix . start_link ( &quot;my_dogmatix&quot; , &quot;localhost&quot; , 8125 , _opts = [ ] ) The returned pid can be used to incorporate in a supervision tree, the provided name ( &quot;my_dogmatix&quot; ) is used to identify the instance and query the Dogmatix API. A few examples of sending data to the agent: # Increment a counter Dogmatix . increment ( &quot;my_dogmatix&quot; , &quot;page.views&quot; ) # Set the value of a gauge Dogmatix . gauge ( &quot;my_dogmatix&quot; , &quot;fuel.level&quot; , 0.5 ) # Increment a counter with tags Dogmatix . count ( &quot;my_dogmatix&quot; , &quot;users.online&quot; , 42 , tags : [ &quot;country:USA&quot; , &quot;app:mobile&quot; ] ) # Sample a histogram 20% of the time Dogmatix . histogram ( &quot;my_dogmatix&quot; , &quot;song.length&quot; , 100 , sample_rate : 0.2 ) # Send an event Dogmatix . event ( &quot;my_dogmatix&quot; , % Event { title : &quot;Exception occurred&quot; , text : &quot;Failed to parse CSV file&quot; , alert_type : :warning } , tags : [ &quot;error_type:input_file&quot; ] ) # Send a service check Dogmatix . service_check ( &quot;my_dogmatix&quot; , % ServiceCheck { name : &quot;DB Connection&quot; , status : :warning , message : &quot;Timed out after 10s&quot; } , tags : [ &quot;env:dev&quot; ] ) The &quot;name-based&quot; API, while providing some flexibility, can be cumbersome. A macro is provided to create custom client modules: defmodule MyDogmatix do use Dogmatix end { :ok , pid } = MyDogmatix . start_link ( &quot;localhost&quot; , 8125 ) MyDogmatix . count ( &quot;users.online&quot; , 42 )","ref":"readme.html#overview","title":"Dogmatix - Overview","type":"extras"},{"doc":"Support for Unix Domain Socket connections Client-side aggregation for some metrics (this is different from metric buffering which is already supported)","ref":"readme.html#features-still-in-the-work","title":"Dogmatix - Features still in the work","type":"extras"},{"doc":"Copyright 2021 Vincent Theron Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :/ / www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"Dogmatix - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"}]